/*
 * Copyright (C) 2008-2009 by the Widelands Development Team
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include "backtrace.h"

#if !defined(WIN32) && !defined(__APPLE__) && !defined(__amigaos4__)
#include <execinfo.h>
#include <cstdlib>
#endif

#define BACKTRACE_STACKSIZE 24

std::string get_backtrace() {
	std::string result("Backtrace:\n");
#if !defined(WIN32) && !defined(__APPLE__) && !defined(__amigaos4__)
	void * stack[BACKTRACE_STACKSIZE];
	size_t size = backtrace(stack, BACKTRACE_STACKSIZE);
	char * * const list = backtrace_symbols(stack, size);
	for (char * const * it = list; size; --size, ++it) {
		result += *it;
		result += '\n';
	}
	free(list);
#endif
	return result;
}
